// *********************************************************************
// Time-stamp: <Montag, 22.04.2002, 20:51:00; edited by heiko>
// 
// demo programm that shows the difference between assigment and
// copy function
// 
// *********************************************************************


#include <iostream>
#include <cstdlib>
#include <trng.h>


int main(void) {
  const long ra_seed=7;
  const long rb_seed=8;

  TRNG::EINV ra(70, ra_seed);
  TRNG::EINV rb(80, rb_seed);
  std::cout << "--- default values ---" << std::endl;
  for (int i=0; i<8; ++i) 
    std::cout << ra.rand() << "\t" << rb.rand() << std::endl;
  // copy ra's status to rb
  // ra and rb generate the same pseudo random nmbers
  TRNG::copy(ra, rb);
  std::cout << "--- copy ---" << std::endl;
  for (int i=0; i<8; ++i) 
    std::cout << ra.rand() << "\t" << rb.rand() << std::endl;

  // rebuild generatos' status after constructor call
  // ra and rb generate different pseudo random nmbers like after
  // constructor call
  ra.reset(); // not realy necessary, did not split or jump
  ra.seed(ra_seed); 
  rb.reset(); // not realy necessary, did not split or jump
  rb.seed(rb_seed);
  std::cout << "--- reset ---" << std::endl;
  for (int i=0; i<8; ++i) 
    std::cout << ra.rand() << "\t" << rb.rand() << std::endl;

  // copy _all_ internal values of ra to rb
  // ra and rb generate the same pseudo random nmbers
  rb=ra;
  std::cout << "--- assigment ---" << std::endl;
  for (int i=0; i<8; ++i) 
    std::cout << ra.rand() << "\t" << rb.rand() << std::endl;

  // rebuild generatos' status after assigment
  ra.reset(); // not realy necessary, did not split or jump
  ra.seed(ra_seed); 
  rb.reset(); // not realy necessary, did not split or jump
  rb.seed(ra_seed); 
  // yes, now we have to use ra_seed, because rb is a full copy of ra
  std::cout << "--- reset ---" << std::endl;
  for (int i=0; i<8; ++i) 
    std::cout << ra.rand() << "\t" << rb.rand() << std::endl;

  return EXIT_SUCCESS;
}
  
