/***********************************************************************
 * Time-stamp: <Samstag, 12.05.2001, 16:41:28; edited by heiko>
 * 
 * Tina's random number generators
 *
 * diehard_file generates a binary input file for the diehard test
 * y Marsaglia; http://stat.fsu.edu/pub/diehard/
 *
 * Copyright by Heiko Bauke, Magdeburg 2001 
 *
 * heiko.bauke@student.uni-magdeburg.de
 *
 * This is free software. You may use and distribute this software under
 * the terms of the GNU GENERAL PUBLIC LICENSE Version 2. See COPYING
 * for details.
 *
 ***********************************************************************/

#include <cstdlib>
#include <iostream>
#include <fstream>
#include <new>
#include <string>
#include <trng.h>

using namespace TRNG;
using namespace std;


template<class RNG_type>
void diehard(RNG_type &r) {
  long q, split;
  string name;
  cout << "splitting level (>0): ";
  cin >> split;
  r.split(split, 0l);
  cout << "file name: ";
  cin >> name;
  ofstream file;
  file.open(name.c_str(), ios::out|ios::binary);
  for (int i=0; i<2621440; ++i) {
    q=r.rand()*2l;
    file.write(reinterpret_cast<const char *>(&q), sizeof(q));
  }
  file.close();
}


int main(void) {
  char c;
  cout << "choose a pseudo random number generator\n\n";
  cout << "  a) ParkMiller\n";
  cout << "  b) LCG32\n";
  cout << "  c) LCG64\n";
  cout << "  d) MRG2\n";
  cout << "  e) MRG3\n";
  cout << "  f) MRG4\n";
  cout << "  g) CLCG2\n";
  cout << "  h) CLCG3\n";
  cout << "  i) CLCG4\n";
  cout << "  j) EINV\n";
  cout << "  k) EINVLCG64\n\n";
  cin >> c; 
  ParkMiller r1;
  LCG32 r2;
  LCG64 r3;
  MRG2 r4;
  MRG3 r5;
  MRG4 r6;
  CLCG2 r7;
  CLCG3 r8;
  CLCG4 r9;
  EINV r10;
  EINVLCG64 r11;
  switch (c) {
  case 'a' : diehard(r1); break;
  case 'b' : diehard(r2); break;
  case 'c' : diehard(r3); break;
  case 'd' : diehard(r4); break;
  case 'e' : diehard(r5); break;
  case 'f' : diehard(r6); break;
  case 'g' : diehard(r7); break;
  case 'h' : diehard(r8); break;
  case 'i' : diehard(r9); break;
  case 'j' : diehard(r10); break;
  case 'k' : diehard(r11); break;
  default : return EXIT_FAILURE;
  }
  return EXIT_SUCCESS;
}

